
#import <Foundation/Foundation.h>

@interface Test: NSObject
{
}

- (id) xxx;
@end

@implementation Test

- (id) xxx
{
    return self;
}

@end

int main (int argc, const char *argv[])
{
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
    id tt = [[Test alloc] init];
    id sign = [tt methodSignatureForSelector: @selector (xxx)];
    id inv  = [NSInvocation invocationWithMethodSignature: sign];

    [inv setSelector: @selector (xxx)];
    printf ("Retain count A: %d\n", [tt retainCount]);
    [inv setTarget: tt];
    printf ("Retain count B: %d\n", [tt retainCount]);
    [inv invoke];
    printf ("Retain count C: %d\n", [tt retainCount]);

    inv = [NSInvocation invocationWithMethodSignature: sign];
    [inv retainArguments];
    [inv setSelector: @selector (xxx)];
    printf ("Retain count D: %d\n", [tt retainCount]);
    [inv setTarget: tt];
    printf ("Retain count E: %d\n", [tt retainCount]);
    [inv invoke];
    printf ("Retain count F: %d\n", [tt retainCount]);
    
    [pool release];
    return 0;     
}
